#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <dirent.h>
#include <stdlib.h>

const int PATHSIZE=300;

void copy(char*src, char*dest) {
  FILE* fsrc;
  FILE* fdest;
  int c;

  fsrc = fopen(src, "r");
  fdest = fopen(dest, "w");

  printf("%s --> %s\n", src, dest);

  if (!(fsrc && fdest)) {
    fprintf(stderr, "Otwarcie pliku nieudane\n");
    return;
  } 

  while (c=getc(fsrc)!=EOF) {
    putc(c, fdest);
  }

  fclose(fsrc);
  fclose(fdest);
}

void scopy(char*src, char*dest, int bufor) {
  int dsrc, ddest;
  int zapisano;
  void*buf = (void*)malloc(sizeof(int)*bufor);

  dsrc = open(src, O_RDONLY);
  ddest = creat(dest, S_IWRITE);

  if (dsrc==-1 || ddest==-1) {
    fprintf(stderr, "Otwarcie pliku nieudane\n");
    return;
  }

  printf("%s --> %s\n", src, dest);

  while (zapisano = read(dsrc, buf, bufor))
    write(ddest, buf, zapisano);

  close(dsrc);
  close(ddest);
  free(buf);
}

void copydir(char*src, char*dest, int rozmiar) {
  DIR* dir;
  struct dirent*pozycja;
  struct stat info;
  char nsrc[PATHSIZE];
  char ndest[PATHSIZE];
  int i;

  if (!(dir = opendir(src))) {
    fprintf(stderr, "Otwarcie katalogu nieudane\n");
    return;
  }

  for (i=0; i<2; i++)
    readdir(dir);

  while (pozycja = readdir(dir)) {
    strcpy(nsrc, src);
    strcat(nsrc, "/");
    strcat(nsrc, pozycja->d_name);

    if (stat(nsrc, &info)) {
      fprintf(stderr, "Nie mozna uzyskac informacji o pliku\n");
      continue;
    }

    strcpy(ndest, dest);
    strcat(ndest, "/");
    strcat(ndest, pozycja->d_name);

    if (!(info.st_mode&S_IFDIR)) {
      if (rozmiar)
	scopy(nsrc, ndest, rozmiar);
      else
	copy(nsrc, ndest);
    } else {
      if (mkdir(ndest, S_IRWXU)) {
	fprintf(stderr, "Nie mozna utworzyc katalogu\n");
	continue;
      }

      copydir(nsrc, ndest, rozmiar);
    }
  }

  closedir(dir);
}

int main(int argc, char** argv) {
  struct stat info1, info2;
  int s=0, rozmiar=0, istnieje2;

  if (argc>1 && !strcmp(argv[1], "-s"))
    s=1;
 
  if (argc<3 || (argc==3 && s) || (argc==4 && s) || (argc==5 && !s) || argc>5) {
    fprintf(stderr, "Niepoprawna liczba argumentow\n");
    return EXIT_FAILURE;
  }

  if (stat(argv[argc-2], &info1)) {
    fprintf(stderr, "Podany argument nie jest plikiem/katalogiem\n");
    return EXIT_FAILURE;
  }

  if (s) {
    sscanf(argv[2], "%d", &rozmiar);
    if (rozmiar<=0) {
      fprintf(stderr, "Bledny rozmiar bufora\n");
      return EXIT_FAILURE;
    }
  }

  istnieje2 = !stat(argv[argc-1], &info2);

  if (info1.st_mode&S_IFREG) {
    if (istnieje2 && !info2.st_mode&S_IFREG) {
      fprintf(stderr, "Plik moze byc skopiowany tylko do pliku\n");
      return EXIT_FAILURE;
    } else if (s)
      scopy(argv[argc-2], argv[argc-1], rozmiar);
    else
      copy(argv[argc-2], argv[argc-1]);
  } else if (info1.st_mode&S_IFDIR) {
    if (istnieje2 && !info2.st_mode&S_IFDIR) {
      fprintf(stderr, "Katalog moze byc skopiowany tylko do katalogu\n");
      return EXIT_FAILURE;
    } else {
      if (!istnieje2)
	if (mkdir(argv[argc-1], S_IRWXU)) {
	  fprintf(stderr, "Nie mozna utworzyc katalogu\n");
	  return EXIT_FAILURE;
	}

      copydir(argv[argc-2], argv[argc-1], rozmiar);
    }
  }

  return EXIT_SUCCESS;
}
