#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>
#include <unistd.h>

int*bufor;

void czytstop() {
  printf("Czytelnik zakonczyl dzialanie!\n");
  exit(EXIT_SUCCESS);
}

void pisstop() {
  printf("Pisarz zakonczyl dzialanie!\n");
  free(bufor);
  exit(EXIT_SUCCESS);
}

int main() {
  int fd[2];
  int ilosc, flagi, pid, zapisano, przeczytano=0;
  void*ptr;

  pipe(fd);
  bufor = (int*)malloc(fpathconf(fd[0], _PC_PIPE_BUF));
  
  signal(SIGUSR1, czytstop);

  flagi = fcntl(fd[1], F_GETFL);
  flagi |= O_NONBLOCK;
  fcntl(fd[1], F_SETFL, flagi);

  flagi = fcntl(fd[0], F_GETFL);
  flagi |= O_NONBLOCK;
  fcntl(fd[0], F_SETFL, flagi);

  if (!(pid=fork())) {
    close(fd[1]);
    signal(SIGUSR1, pisstop);

    printf("Czytelnik gotowy\n");

    for (;;) {
      sleep(5);
      ilosc = read(fd[0], bufor, fpathconf(fd[0], _PC_PIPE_BUF));

      if (ilosc>0) {
	printf("Czytelnik przeczytal %d bajtow\n", ilosc);
	przeczytano=0;
      }
      else if (ilosc==-1) {
	if (++przeczytano==2) {
	  kill(getppid(), SIGUSR1);
	  free(bufor);
	  exit(EXIT_SUCCESS);
	}
      }
      fflush(stdout);
    }
  }

  close(fd[0]);
  free(bufor);

  printf("Pisarz gotowy\n");

  for (;;) {
    printf("Podaj ilosc bajtow do przeslania (0 = koniec):\n");
    ilosc=0;
    scanf("%d", &ilosc);

    if (ilosc<1)
      break;

    ptr = (void*)malloc(ilosc);

    zapisano = write(fd[1], ptr, ilosc);
    if (zapisano!=ilosc && zapisano>=0)
      printf("Potok zostal zapelniony - zapisano jedynie %d bajtow\n", zapisano);
    else if (zapisano==-1)
      printf("Potok pelny - nie mozna nic zapisac\n");

    free(ptr);
  }

  kill(pid, SIGUSR1);
  wait(0);
  return EXIT_SUCCESS;
}
